//*****************************************************************************
//* Copyright (c) 1995-2000 Palm, Inc. or its subsidiaries.
//* Copyright (c) 2001 Sony Corporation.
//* Copyright (c) 2002-2005 Miday Workshop All rights reserved.
//*
//* File: DateMain.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>
#include <BtLib.h>
#include <BtExgLib.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//global variables

//\  (Struct)
OPTIONS2 Opt2;
//Version 3.3 Update Start
OPTIONS3 Opt3;
OPTIONS33 Opt_g, Opt_p;//Opt_p͐ݒʁA]ʏI̐ݒlۑł̂ݎgp  ("Opt_p" is only for "Prof" and "Beem" screen. It registers, when closing a screen.)
//Version 3.3 Update End
COLOR_DEF Color_def[Max_Color_no];
BEAM_HEADER Beam_hd;

FormPtr  frm;
ListType *lstTable;
unsigned short cardNo = 0;

//gK[p̗̈    (The domain for triggers.  Start)
short Year_no;		//gK[ŕ\N   (The years displayed by a trigger)
short Month_no;		//gK[ŕ\錎   (The months displayed by a trigger)

char Start_Year_data[10][7], *Start_Year_table[10], Start_Month_data[12][5], *Start_Month_table[12];
char End_Year_data[10][7],   *End_Year_table[10],   End_Month_data[12][5],   *End_Month_table[12];

char memorial1_Year_data[11][7],  *memorial1_Year_table[11];
char memorial1_Month_data[12][5], *memorial1_Month_table[12];
char memorial1_Day_data[31][5],   *memorial1_Day_table[31];
short memorial1_Day_no;

char memorial2_Year_data[11][7],  *memorial2_Year_table[11];
char memorial2_Month_data[12][5], *memorial2_Month_table[12];
char memorial2_Day_data[31][5],   *memorial2_Day_table[31];
short memorial2_Day_no;

char memorial3_Year_data[11][7],  *memorial3_Year_table[11];
char memorial3_Month_data[12][5], *memorial3_Month_table[12];
char memorial3_Day_data[31][5],   *memorial3_Day_table[31];
short memorial3_Day_no;

char memorial4_Year_data[11][7],  *memorial4_Year_table[11];
char memorial4_Month_data[12][5], *memorial4_Month_table[12];
char memorial4_Day_data[31][5],   *memorial4_Day_table[31];
short memorial4_Day_no;

char Beam_Start_Year_data[10][7], *Beam_Start_Year_table[10], Beam_Start_Month_data[12][5], *Beam_Start_Month_table[12];
char Beam_End_Year_data[10][7],   *Beam_End_Year_table[10],   Beam_End_Month_data[12][5],   *Beam_End_Month_table[12];

char Color_data[Max_Color_no+2][9],   *Color_table[Max_Color_no+2];
char Color_w_data[Max_Color_no+2][9], *Color_w_table[Max_Color_no+2];
char Color_h_data[Max_Color_no+2][9], *Color_h_table[Max_Color_no+2];
//gK[p̗̈  ܂ (The domain for triggers.  End)

//Ff[^x[XpgK[p̗̈    (The domain for color database triggers.  Start)
char Trigger_file_data[20][10];
char* Trigger_file_table[20];
short Trigger_file_no;
char trigger_file_title[100];
//Ff[^x[XpgK[p̗̈  ܂  (The domain for color database triggers.  End)

//Ff[^x[Xpt@C    (Color database file information.  Start)
char Col_file[Max_Color_File_no][20];
short Col_data_no;
LocalID Col_dbIDP[Max_Color_File_no];
//Ff[^x[Xpt@C  ܂  (Color database file information.  End)


short TextColor, BackColor;   //Version 3.3a add
short Color_no;			//ݑĨJ[    (The color of the present selection.)
short Color_dev_type;	//xf[^`foCX̃^Cv    (The type of the device which defined holiday data.)

short OS_Color_Support;	//=1  J[@  !=1  mN@    (=1 Color device  !=1 Monochrome device)
//short OS_Ver_no;		//OS̃o[W    (The version of OS)
short Lang;				//=1  p  =2  {    (=1 English  =2 Japanese)
//Version 3.3 Add Start
short Easter;			//=0@\@=1@\    (=0 Un-displaying  =2 Display)
//Version 3.3 Add End

//   "F̐ݒ",          "wȂ",            "",         "x"
//   "col def",          "normal",              "week",         "holi"
char ColorDefString[20], ColorNormalString[20], WeekString[20], HolDefString[20];
//   "PQEE"  "ΐ؋y"
//   "Jan Feb..."   "sun mon..."
char Monthname[61], Weekname[15], Year_suffix[10], Month_suffix[10], Day_suffix[10];

short Back_md_flag,//=0  Cʂ琗^ʂ  =1  ̉ʂ琗^ʂ
                   //=0 From the main screen to the model screen.   =1 From other screens to the model screen.
      Back_me_flag;//=0  ^ʂLOʂ  =1  ̉ʂLOʂ
                   //=0 From the model screen to the memorial screen.   =1 From other screens to the memolial screen.

short Max_over_color_flag,//=0  xf[^t@Cɂ͍őFȉ̐F`  =1  őF𒴂F`
                          //=0 The definition of a color is seven or less colors.
                          //=1 The definition of a color exceeded seven colors.
      Max_over_text_flag;//=0  xf[^t@Cɂ͍ő啶ȉ̐`  =1  ő啶𒴂`
                          //=0 The definition of a text is eight or less  characters.
                          //=1 The definition of a text exceeded eight characters.

short Color_win_max_color;	//F̍ڐݒʂŒ`F̐    (The number of the present colors.)

short Color_call_win;	//F̍ڐݒʂĂ񂾉    (The screen which called the "color screen".)

short Stop_flag;		//=0  vOI  =1  I    (=0 A program can be finished.  =1 A program cannot be finished.)
short MainWinRedraw;	//=0  hEsv  =1  Kv          (=0 Redraw is not necessity  =1 Redraw is necessity)
short Dataupdateflag;	//=0  f[^͍XVĂȂ  =1  XV    (=0 The data which has not updated  =1 Data was updated)

short Yasumi_no, Yasumi_max_no;	//݂̌  `\Ȍ    (The present number of the months. The number of the months which can be defined.)
short Sv_st_year, Sv_st_month, Sv_en_year, Sv_en_month, Sv_month_no;	//JeS[Qp  JnN  Jn  IN  I    (It is used by a category 2.)

short Start_year;	//JnNi̔N|Qj    (Inaugural year (today's year -2))
short Cu_Year, Cu_Month;	//̔NA    (today's year, today's month)

MemHandle Yasumi_mem_hndl;

unsigned char Yasumi_dis[4][31];	//SRP̐F̔ԍ    (Number of a color(four months))
short Yasumi_year_dis[4], Yasumi_month_dis[4], Yasumi_no_dis[4];	//S̔NAAz̔ԍ(year,month,the the number of array(four months))

unsigned char Color_table_bit[Max_Color_no] = {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02};//eFR[h̃rbgʒu    (The bit position of each color code.)

short Beam_trnce_flag;	//=1,3  ԊO/BluetoothM  =2,4  ԊO/BluetoothM  (=1,3 Infrared/Bluetooth transmitting screen  =2,4 Infrared receiving/Bluetooth screen)
MemHandle      BeamMemH;//ԊOf[^p    (For infrared data)

//Version 3.2 Add Start
short Bluetooth_libflag;//=0 Bluetooth lib not found  =1 Bluetooth lib found

DY_PREFDATA Dy_PrefGetData, Dy_PrefSetData;//INpf[^  (Dynamic starting data area)
//Version 3.2 Add End

//private value
MenuBarPtr		CurrentMenu;
static void StopApplication ();

//UInt16 **maskPP;
SonySysFtrSysInfoP sonySysFtrSysInfoP;
//UInt16 mask[] = {sonyJogAstMaskType2, 0x7f};
////UInt16 mask[] = {sonyJogAstMaskType1, 1, FirstDialog, 0x7f};
//UInt16 *oldmaskP;

//--------------------------------------------------------
//@AvP[VJn
//  Application start.
//--------------------------------------------------------
static UInt16 StartApplication (){
	DateTimeType dateTime;
	Err err = 0;
	unsigned long currentRecordID = 0;
	Boolean recordFound = false;
	Err error;
	unsigned long width, height;
	unsigned short hrRefNum;
	MemHandle StringH;
	char      *StringP;
	unsigned long romVersion;
	short ix;
	UInt32 depth;

//nC][h    (High resolution mode(sony clie)  Start)
	if (!FtrGet(sonySysFtrCreator, sonySysFtrNumSysInfoP, (unsigned long*)&sonySysFtrSysInfoP)) {
		if (sonySysFtrSysInfoP->libr & sonySysFtrSysInfoLibrHR) {
			error = SysLibFind(sonySysLibNameHR, &hrRefNum);
			if ( error ) {
				if (error == sysErrLibNotFound) {
					error = SysLibLoad('libr', sonySysFileCHRLib, &hrRefNum);
				}
			}
			if ( !error ) {
				width = height = 320;
				HROpen(hrRefNum);
				HRWinScreenMode(hrRefNum, winScreenModeSet, &width, &height, NULL, NULL );
				HRClose(hrRefNum);
			}
		}
	}
//nC][h    (High resolution mode(sony clie)  End)

	Stop_flag = 0;
	Year_no   = 10;
	Month_no  = 12;


	Dataupdateflag = 0;
	StringH = DmGetResource(strRsc, Stringbyte);//byte
	StringP = MemHandleLock(StringH);
	if ( StringP[0] == '1' ) {
		Lang = 1;
	} else {
		Lang = 2;
	}
	MemHandleUnlock(StringH);

//Version 3.3 Add Start
	StringH = DmGetResource(strRsc, StringEasterFlag);//Easter
	StringP = MemHandleLock(StringH);
	if ( StringP[0] == '0' ) {
		Easter = 0;
	} else {
		Easter = 1;
	}
	MemHandleUnlock(StringH);
//Version 3.3 Add End

	StringH = DmGetResource(strRsc, StringWeekName);//ΐ؋y    (sun mon...)
	StringP = MemHandleLock(StringH);
	StrCopy(Weekname, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringColorDef);
	StringP = MemHandleLock(StringH);
	StrCopy(ColorDefString, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringNormal);
	StringP = MemHandleLock(StringH);
	StrCopy(ColorNormalString, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringWeekDay);
	StringP = MemHandleLock(StringH);
	StrCopy(WeekString, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringHoliday);
	StringP = MemHandleLock(StringH);
	StrCopy(HolDefString, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringMonthName);
	StringP = MemHandleLock(StringH);
	StrCopy(Monthname, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringYEAR);
	StringP = MemHandleLock(StringH);
	StrCopy(Year_suffix, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringMONTH);
	StringP = MemHandleLock(StringH);
	StrCopy(Month_suffix, StringP);
	MemHandleUnlock(StringH);

	StringH = DmGetResource(strRsc, StringHI);
	StringP = MemHandleLock(StringH);
	StrCopy(Day_suffix, StringP);
	MemHandleUnlock(StringH);

//nro[W荞    (OS version is checked.)
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < sysMakeROMVersion(3,5,0,sysROMStageRelease,0)) {
//		OS_Ver_no = 31;
		OS_Color_Support = 0;
	} else {
//		OS_Ver_no = 35;
//		if (UIColorGetTableEntryIndex(UIObjectSelectedFill) != UIColorGetTableEntryIndex(UIObjectForeground)) {//Color?
//			OS_Color_Support = 1;
//		} else {
//			OS_Color_Support = 0;
//		}
		error = WinScreenMode(winScreenModeGet, NULL, NULL, &depth, NULL);
		if ( depth > 4 ) {
			OS_Color_Support = 1;
			BackColor = WinSetBackColor (UIColorGetTableEntryIndex(UIFormFill));  //Version 3.3a add
			TextColor = WinSetTextColor (UIColorGetTableEntryIndex(UIObjectForeground)); //Version 3.3a add
		} else {
			OS_Color_Support = 0;
		}
	}

//Version 3.2 Add Start
	file_name_change();
//Version 3.2 Add End

	if ( Dy_PrefGetData.From  == 2 ) {
		Cu_Year  = Dy_PrefGetData.Year;    //Version 3.2 Add
		Cu_Month = Dy_PrefGetData.Month;   //Version 3.2 Add
	} else {
		Yasumi_no = 0;
		TimSecondsToDateTime (TimGetSeconds (), &dateTime);
		Start_year = dateTime.year-2;
		Cu_Year    = dateTime.year;
		Cu_Month   = dateTime.month;
	}

	Md_GetDatabase(1, Dt_FileName);//Փf[^荞    (Holiday data input.)

//tB[`̈悩荞    (It inputs from a feature domain.)
	GetPreferences();

	if ( Opt_g.hol_count_flag == 1 ) {//tB[`ƃt@C̕sC    (The mismatching of feature and a file is corrected.)
		for ( ix=0; ix<MAX_MEMORIAL_DEFNO; ix++ ) {
			if ( Opt_g.memorial_col1[ix] != 0 ) {
				if ( Color_def[Opt_g.memorial_col1[ix]-1].hol_flag == 0 ) Opt_g.memorial_col1[ix] = 0;
			}
			if ( Opt_g.memorial_col2[ix] != 0 ) {
				if ( Color_def[Opt_g.memorial_col2[ix]-1].hol_flag == 1 ) Opt_g.memorial_col2[ix] = 0;
			}
		}
	}

	MemMove(&Opt_p.version, &Opt_g.version, sizeof(OPTIONS33));

	for ( ix=0; ix< Max_Color_no+2; ix++ ) {
		Color_table[ix]     = Color_data[ix];
		Color_w_table[ix]   = Color_w_data[ix];
		Color_h_table[ix]   = Color_h_data[ix];
	}

	Color_no = 1;

	return (err);
}

//--------------------------------------------------------
//@AvP[V~
//  Application stop.
//--------------------------------------------------------
static void StopApplication (){

	//f[^x[XN[Y
//	DmCloseDatabase ( dbP );
//	PrefSetAppPreferences (Df_CreaID, 1, Md_Version, &Opt2, sizeof(OPTIONS2), true);
//	PrefSetAppPreferences (Df_CreaID, 2, Md_Version, &Opt3, sizeof(OPTIONS3), true);

	//̈̊J    (Release of a domain.)
	MemHandleFree(Yasumi_mem_hndl);

	//SẴtH[N[Y    (All forms are closed.)
	FrmCloseAllForms ();
}

//--------------------------------------------------------
//@CxgnhO
//   Event handling.
//--------------------------------------------------------
static Boolean ApplicationHandleEvent (EventType * event){
	unsigned short formID;
	FormPtr frm;

	if (event->eType == frmLoadEvent){
		//tH[̃\[X[h    (The resource of form is loaded.)
		formID = event->data.frmLoad.formID;
		frm = FrmInitForm (formID);
		FrmSetActiveForm (frm);		

		//CxgnhO[`Ă    (An event handling routine is called.)
		switch (formID){
		case MainWin:
			FrmSetEventHandler (frm, MainWinHandleEvent);
			break;

		case Model:
			FrmSetEventHandler (frm, ModelHandleEvent);
			break;

		case MemorialWin:
			FrmSetEventHandler (frm, MemorialWinHandleEvent);
			break;

		case Preferences:
			FrmSetEventHandler (frm,PreferencesHandleEvent);
			break;

		case Tools:
			FrmSetEventHandler (frm, ToolsHandleEvent);
			break;

		case BeamWin:
			FrmSetEventHandler (frm, BeamWinHandleEvent);
			break;

		case ColorDefine:
			FrmSetEventHandler (frm, ColorDefineHandleEvent);
			break;

		case AboutDialog:
			FrmSetEventHandler (frm, AboutHandleEvent);
			break;

		}
		return (true);
	}
	return (false);
}

//--------------------------------------------------------
//@Cxg[v
//  Event loop.
//--------------------------------------------------------
static void EventLoop (){
	unsigned short error;
	EventType event;
	short ix, iy, ia, ka, kb;
	
	do{
		EvtGetEvent (&event, evtWaitForever);

		if ( event.eType == appStopEvent ) {
			if ( Dataupdateflag == 1 ) {
				if ( FrmAlert(AltExit) == 0 ) {
					iy = 0;
					if ( Max_over_color_flag != 0 ) {
						if ( FrmAlert(AltColorOverSave) != 0 ) {
							iy = 1;
						}
					}
					if ( Max_over_text_flag != 0 ) {
						if ( FrmAlert(AltTextOverSave) != 0 ) {
							iy = 1;
						}
					}
					if ( iy == 0 ) {
						for ( kb=0; kb<2; kb++ ) {
							for ( ka=0; ka<2; ka++ ) {
								ia = SetRedDataOfArray(Yasumi_year_dis[kb*2+ka], Yasumi_month_dis[kb*2+ka], &Yasumi_dis[kb*2+ka][0], Yasumi_no_dis[kb*2+ka]);
							}
						}
						ix = Md_SetDatabase(1, Dt_FileName);
						PrefSetAppPreferences (Df_CreaID, OPT_ID, Md_Version, &Opt_g, sizeof(OPTIONS33), true);
					}
				}
			}
		}

		if (! SysHandleEvent (&event))
			if (! MenuHandleEvent (CurrentMenu, &event, &error))
				if (! ApplicationHandleEvent (&event))
					FrmDispatchEvent (&event); 
	} while ((event.eType != appStopEvent) && Stop_flag == 0 );
}

//--------------------------------------------------------
//@ʏN
//  Normal Launch
//--------------------------------------------------------
static LaunchCmdNormalLaunch(UInt16 launchFlags) {
	unsigned short error;
	UInt32	btVersion;
	unsigned short prefsSize;

	//BluetoothCu`FbN    (Bluetooth library check)
	Bluetooth_libflag = 1;
	if (FtrGet(btLibFeatureCreator, btLibFeatureVersion, &btVersion) != errNone) {
		if ((launchFlags & sysAppLaunchFlagNewGlobals) && (launchFlags & sysAppLaunchFlagUIApp))
			Bluetooth_libflag = 0;
	}

	ExgRegisterData(Df_CreaID, exgRegExtensionID, Bm_DataType);

	//IN`FbN  (Dynamic starting check)
	prefsSize = sizeof (DY_PREFDATA);
	if( (PrefGetAppPreferences (Df_CreaID, Dy_to_ID, &Dy_PrefGetData, &prefsSize, true) == noPreferenceFound) 
	 || ( prefsSize != sizeof(DY_PREFDATA))) {
		Dy_PrefGetData.From  = 0;
		Dy_PrefGetData.Month = 0;
		Dy_PrefGetData.Year  = 0;
	}
	Dy_PrefSetData.From = 0;
	PrefSetAppPreferences (Df_CreaID, Dy_to_ID, Dy_to_VerNum, &Dy_PrefSetData, sizeof (DY_PREFDATA), true);

	error = StartApplication ();
	if (error) return (error);

	MainWinRedraw = 0;
	FrmGotoForm (MainWin);
	EventLoop ();
	StopApplication ();
	return (errNone);
}

//--------------------------------------------------------
//@ԊO/BluetoothM
//  Infrared rays/Bluetooth are received.
//--------------------------------------------------------
static void LaunchCmdExgAskUser(MemPtr cmdPBP, UInt16 launchFlags) {
	ExgAskParamPtr exgparamP;
	unsigned short optsize;
	exgparamP = (ExgAskParamPtr)cmdPBP;

	optsize = sizeof(OPTIONS33);
	//ԊO/BluetoothM\`FbN    (Can infrared reception/Bluetooth be performed?)
	GetPreferences();
	if ( Opt_g.beam_opt == 1 ) {  //ԊO/BluetoothMnj    (Infrared reception/Bluetooth O.K.)
		if (!(launchFlags & sysAppLaunchFlagSubCall)) {
			if (FrmAlert(AltMakeSpotRun) == 0) {
				exgparamP->result = exgAskOk;
			} else {
				exgparamP->result = exgAskCancel;
			}
		} else {
			exgparamP->result = exgAskOk;
		}
	} else {
		FrmAlert(AltBeamCannot);
		exgparamP->result = exgAskCancel;
	}
}

//--------------------------------------------------------
//@ԊO/BluetoothN
//  Launch and go to a particular record.
//--------------------------------------------------------
static LaunchCmdGoTo(MemPtr cmdPBP, UInt16 launchFlags) {
	MemHandle      MemH;
	unsigned char  *MemP;
	unsigned short error;
	short          cmd_flag;
	UInt32	btVersion;

	MemH = (MemHandle)((GoToParamsPtr)cmdPBP)->matchCustom;
	MemP = MemHandleLock(MemH);

	//BluetoothCu`FbN    (Bluetooth library check)  Ver3.2 Add
	Bluetooth_libflag = 1;
	if (FtrGet(btLibFeatureCreator, btLibFeatureVersion, &btVersion) != errNone) {
		if ((launchFlags & sysAppLaunchFlagNewGlobals) && (launchFlags & sysAppLaunchFlagUIApp))
			Bluetooth_libflag = 0;
	}

	error = StartApplication ();
	if (error) return (error);

	MemMove (&cmd_flag, &MemP[0], 2);
	if ( cmd_flag == 1 ) {  //ԊO/BluetoothM  (Infrared/Bluetooth parameter)
		ReceiveDataBackup(&MemP[2]);
		Beam_trnce_flag = 2;
	}
	MemHandleUnlock(MemH);
	MemHandleFree(MemH);

	MainWinRedraw = 0;
	FrmGotoForm(MainWin);

	EventLoop ();
	FrmCloseAllForms ();
	return (errNone);
}

//--------------------------------------------------------
//@C֐
//  Main.
//--------------------------------------------------------
UInt32	PilotMain (UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags){
	unsigned short error;

	switch (cmd) {
	case sysAppLaunchCmdNormalLaunch://ʏN
		LaunchCmdNormalLaunch(launchFlags);
		break;

//	case sysAppLaunchCmdSyncNotify:
//	case sysAppLaunchCmdSystemReset://Zbg
//		ExgRegisterData(Df_CreaID, exgRegExtensionID, Bm_DataType);   //version 3.1a
//		break;

	case sysAppLaunchCmdExgAskUser://ԊO󂯂
		LaunchCmdExgAskUser(cmdPBP, launchFlags);
		break;

	case sysAppLaunchCmdExgReceiveData://ԊOŎ󂯂f[^̕ۑ    (Preservation of receiving data.)
		ReceiveData((ExgSocketPtr)cmdPBP);
		break;

	case sysAppLaunchCmdGoTo:
		error = LaunchCmdGoTo(cmdPBP, launchFlags);
		if (error) return (error);
		break;
	}

	return (errNone);
}
