//*****************************************************************************
//* Copyright (c) 2001-2004 Miday Workshop All rights reserved.
//*
//* File: About.c
//*****************************************************************************

#include <PalmOS.h>
#include <SonyCLIE.h>
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//--------------------------------------------------------
//@ݒ
//  Initial setting.
//--------------------------------------------------------
static void DisplayAboutInit () {
	FontID fontsize;

	WinSetUnderlineMode(noUnderline);
	fontsize = FntSetFont(stdFont);
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean AboutHandleEvent (EventType * event) {
	Boolean handled = false;

	if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case AboutModoruButton:
			FrmReturnToForm (0);
			handled = true;
			break;
		}
	} else if (event->eType == frmOpenEvent) {
		DisplayAboutInit ();
		FrmDrawForm (FrmGetActiveForm ());
		handled = true;
	}

	return (handled);
}
