//*****************************************************************************
//* Copyright (c) 2002-2005 Miday Workshop All rights reserved.
//*
//* File: DefDef.h
//*****************************************************************************

//f[^t@CNG[^hc  (Data file creator ID)
#define Dt_CreaID		'Md02'
//x`NG[^hc        (MakeSpot creator ID )
#define Df_CreaID		'Md08'
//f[^f[^^Cvixf[^j    (Data file Data type(Holiday data file))
#define Dt_DBType		'Data'
//f[^f[^^CviFf[^j      (Data file Data type(Color file))
#define Df_ClType		'Colf'
//Version 3.2 Add Start
//ʐMf[^f[^^Cv      (Communication data type)
#define Bm_DataType		"Spot"
//Version 3.2 Add End

//Version 3.2 Add Start
//x`ʐMvgRx[Xo[W      (Communications protocol version)
#define Md_CPVersion	1
//x`f[^f[^x[Xo[W        (DataBase version)
#define Md_DBVersion	3
//Version 3.2 Add End

//x`f[^o[W        (Data form version)
#define Md_Version		3

//Version 3.3 Add Start
//tB[`ԍ(V3.3p)        (feature ID for version 3.3)
#define OPT_ID			2
//Version 3.3 Add End

//Version 3.2 Add Start
//x`INptB[`ԍ        (Dynamic starting feature number)
#define Dy_to_ID		29
//x`INptB[`o[W  (Dynamic starting feature version)
#define Dy_to_VerNum	1
//Version 3.2 Add End

//xf[^t@C                ("Holiday data file" name)
//Version 3.2 Update Start
//--------------------------------
//#define Dt_FileName	"DateSpot.pdb"
//-------------------------------- Ver 3.1c or 3.1d
//#define Dt_FileName		"DateSpot.pdb"
//#define Dt_FileName_old	"MakeSpotData"
//-------------------------------- Ver 3.2 or later
#define Dt_FileName_old	"DateSpot.pdb"
#define Dt_FileName		"MakeSpotData"
//--------------------------------
//Version 3.2 Update End

//x\t@C                    (Datespot file name)
//#define Ap_FileName	"Date Spot"
//Ff[^̐擪                    ("Color files" name Prefix)
#define Col_FileName	"DateCol_"
//Version 3.2 Update Start
//Ff[^̖                    ("Color files" name Suffix)
#define Col_FileSuffix		".pdb"
//Version 3.2 Update End

//őFt@C                    (number of max "color files")
#define Max_Color_File_no 32

//őJ[                        (number of max colors)
#define Max_Color_no 7

//ő啶                          (number of max texts)
#define Max_ColorText_no 9

//TԂ̓                        (The days for one week)
#define WEEK_DAYS_NO 7

//LO̐                          (The number of memorial days)
#define MAX_MEMORIAL_DEFNO 4

//Version 3.3 Add Start
//Փ̐F̏l                    (The initial value of the color of National holiday)
#define Hol_Color_Init 1

//C[X^[̐F̏l              (The initial value of the color of Easter)
#define Easter_Color_Init 3
//Version 3.3 Add End

typedef struct {
	short st_year;				//JnN
	short st_month;				//Jn
	short en_year;				//IN
	short en_month;				//I
	short memorial_flag[3];		//LOgptO
	short memorial_year[3];		//LO̔N
	short memorial_month[3];	//LǑ
	short memorial_day[3];		//LO̓
	short memorial_col1[3];		//LO̐F
	short week_color[7];		//ej̐F
	short hol_color;			//Փ̐F
}OPTIONS2;

typedef struct {
	short version;				//(=3 o[WR)
//ݒ  (Option screen)
	short data_ver;				//o[WQ̃f[^쐬邩ۂ
	short hol_count_flag;		//=1@xtOL@=0@xtO
//^ʂ̏  (Model screen)
	short st_year;				//JnN
	short st_month;				//Jn
	short en_year;				//IN
	short en_month;				//I
//LO  (Memorial screen)
	short memorial_flag[4];		//LOgptO
	short memorial_hol_flag[4];	//LŐxtO
	short memorial_year[4];		//LO̔N
	short memorial_month[4];	//LǑ
	short memorial_day[4];		//LO̓
	short memorial_col1[4];		//LO̐F@
	short memorial_col2[4];		//LO̐F@x
//^ʂ̉  (Model screen)
	short week_color[7];		//ej̐F
	short hol_color;			//Փ̐F
//ԊOʐM  (Beam screen)
	short beam_opt;				//ԊOLɂ邩
	unsigned short beam_flag;	//ԊOőSẴf[^] + F] * 2
	short beam_st_year;			//JnN
	short beam_st_month;		//Jn
	short beam_en_year;			//IN
	short beam_en_month;		//I
}OPTIONS3;

//Version 3.3 Add Start
typedef struct {
	short version;				//(=3 o[WR)
//ݒ  (Option screen)
	short data_ver;				//o[WQ̃f[^쐬邩ۂ
	short hol_count_flag;		//=1@xtOL@=0@xtO
//^ʂ̏  (Model screen)
	short st_year;				//JnN
	short st_month;				//Jn
	short en_year;				//IN
	short en_month;				//I
//LO  (Memorial screen)
	short memorial_flag[4];		//LOgptO
	short memorial_hol_flag[4];	//LŐxtO
	short memorial_year[4];		//LO̔N
	short memorial_month[4];	//LǑ
	short memorial_day[4];		//LO̓
	short memorial_col1[4];		//LO̐F@
	short memorial_col2[4];		//LO̐F@x
//^ʂ̉  (Model screen)
	short week_color[7];		//ej̐F
	short hol_color;			//Փ̐F
	short easter_color;			//C[X^[̐F
//ԊOʐM  (Beam screen)
	short beam_opt;				//ԊOLɂ邩
	unsigned short beam_flag;	//ԊOőSẴf[^] + F] * 2
	short beam_st_year;			//JnN
	short beam_st_month;		//Jn
	short beam_en_year;			//IN
	short beam_en_month;		//I
}OPTIONS33;
//Version 3.3 Add End

typedef struct {//F̍ڐݒʂŒ`
	short            hol_flag;					//=1@ɋx@=0@xƂ͌Ȃ
	IndexedColorType color1_b;					//wi
	IndexedColorType color1_t;					//
	IndexedColorType color2_b;					//Owi
	IndexedColorType color2_t;					//O
	RGBColorType     rgbcolor1_b;
	RGBColorType     rgbcolor1_t;
	RGBColorType     rgbcolor2_b;
	RGBColorType     rgbcolor2_t;
	char             text[Max_ColorText_no];	//F̐
}COLOR_DEF;

typedef struct {
	short total_byte;			//Ŝ̃oCg
	short form_ver;				//f[^̃o[W
	short beam_ver;				//]vgR̃o[W
	short color_number;			//F
	short beam_com;				//𑗂邩ۂ̃tO
	short mounth_number;		//
	short start_year;			//JnN
	short start_month;			//Jn
	short end_year;				//IN
	short end_month;			//I
}BEAM_HEADER;

//Version 3.2 Add Start
typedef struct {
	long  CrID;
	short From;
	short Year;
	short Month;
	unsigned short Other[11];
} DY_PREFDATA;
//Version 3.2 Add End
