//*****************************************************************************
//* Copyright (c) 2003-2005 Miday Workshop All rights reserved.
//*
//* File: Pref.c
//*****************************************************************************

#include <PalmOS.h>
#include <SonyCLIE.h>
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean PreferencesHandleEvent (EventType * event) {
	Boolean handled = false;
	//Version 3.2 Add Start
	short ia;
	//Version 3.2 Add End

	frm = FrmGetFormPtr (Preferences);

	if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case PreferencesOKButton:
			Opt_g.data_ver       = 3 - CtlGetValue(GetObjectPtr(PreferencesV2CheckBox));
			Opt_g.hol_count_flag = CtlGetValue(GetObjectPtr(PreferencesHolCheckBox));
			Opt_g.beam_opt       = CtlGetValue(GetObjectPtr(PreferencesBeamCheckBox));
			Opt_p.data_ver       = Opt_g.data_ver;
			Opt_p.hol_count_flag = Opt_g.hol_count_flag;
	//Version 3.2 Add Start
			if ( Opt_p.hol_count_flag == 0 ) {
				for (ia=0; ia<Max_Color_no; ia++) {
					Color_def[ia].hol_flag = 1;
				}
			}
	//Version 3.2 Add End
			Opt_p.beam_opt      = Opt_g.beam_opt;
			PrefSetAppPreferences (Df_CreaID, OPT_ID, Md_Version, &Opt_p, sizeof(OPTIONS33), true);
			FrmGotoForm (MainWin);
			handled = true;
			break;
		case PreferencesCancelButton:
			FrmGotoForm (MainWin);
			handled = true;
			break;
		}

	} else if (event->eType == menuEvent) {
		switch (event->data.menu.itemID) {
		case AboutAboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	} else if (event->eType == frmOpenEvent) {
		CtlSetValue(GetObjectPtr(PreferencesV2CheckBox),3-Opt_g.data_ver);
		CtlSetValue(GetObjectPtr(PreferencesHolCheckBox),Opt_g.hol_count_flag);
		CtlSetValue(GetObjectPtr(PreferencesBeamCheckBox),Opt_g.beam_opt);
		FrmDrawForm (frm);
		handled = true;
	}

	return (handled);
}
